""" Demonstration of megawidget destruction.
"""

# Import Pmw from the sibling directory.
import sys
sys.path[:0] = ['../../..']

import Tkinter
import Pmw

class Demo:
    def __init__(self, parent):
	# Create and pack an EntryField.
	self.entry = Pmw.EntryField(parent,
	    command = self.execute,
	    entry_width = 30)
	self.entry.pack(fill='x', expand=1, padx=10, pady=5)
	self.entry.insert(0, 'Press <Return> to destroy me')

	self.entry.component('entry').focus_set()

    def execute(self):
	print 'Return pressed, destroying EntryField.'
	self.entry.destroy()

######################################################################

# Create demo in root window for testing.
if __name__ == '__main__':
    root = Tkinter.Tk()
    Pmw.initialise(root, fontScheme = 'pmw1')
    root.title('Pmw megawidget destruction demonstration')

    exitButton = Tkinter.Button(root, text = 'Exit', command = root.destroy)
    exitButton.pack(side = 'bottom')
    widget = Demo(root)
    root.mainloop()
